# LabVIEW Modbus API
The MODBUS library is a free, downloadable set of Virtual Instruments (VIs) that provide Modbus communication from any standard Ethernet or serial port. The LabVIEW library implements the Modbus protocol in software and offers both master and slave functionality. Using the Modbus library, Programmable Automation Controllers (PACs) can communicate with gateway devices that provide connectivity to a wide variety of industrial networks, such as PROFIBUS, EthernetIP, and DeviceNet.
A newer library, intended as a replacement for this one, was added to ni.com/labs. This is not an official NI Product. 

###Contribution Workflow: For a more complete workflow, view this set-up guide and this workflow guide.
1) Create an issue or assign the existing issue to you.
2) Fork this repository into your account.
3) Create a branch for your change.
4) Make changes, periodically pulling and merging any updates from the central repository.
5) Push your changes up to your branch in your copy of the repository.
6) Send a pull request to the owner of this primary repository. Follow the contribution guidelines.



###Contribution Guidelines:

1) Limit the scope of your change as much as possible. Smaller changes are easier to process. Any major changes should be discussed beforehand with the managers of the repository to ensure that it fits within the goals and vision of the project.
2) Explain the reason for your change with as much detail as possible. If it is a bugfix, link it to an issue in the issues tracker. If it is an enhancement, consider making an issue in the issue tracker to discuss the enhancement before making it. This ensures that the enhancement will provide value to other users.
3) Run through the style guidelines and any available VI analyzer tests to ensure compliance with the general style of the project. Don't go crazy trying to make the code perfect. Do make sure there are no glaring issues.
4) Before committing a change, be sure to rebase or merge your code off of the most up-to-date source in the master. This reduces the risk of merge conflicts and makes it that much easier to merge your pull request and that much more likely that the change will be accepted.
5) Ensure that all builds are successful with your change in place, after rebasing.
6) Ensure that all tests pass with your change in place, after rebasing.
7) LabVIEW 2014
